Package com.saxonica.functions.extfn

## Class EXPathBinary

- java.lang.Object
- - com.saxonica.functions.extfn.EXPathBinary

-     public class EXPathBinary
      extends java.lang.Object

  Implementation of extension functions in the EXPath Binary package, see http://expath.org/spec/binary

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ERROR_NAMESPACE` |
    `static java.lang.String` | `ERROR_PREFIX` |
    `static java.lang.String` | `NAMESPACE` |
    `static java.lang.String` | `PREFIX` |
    `static double` | `VERSION` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EXPathBinary()` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static ZeroOrOne<Base64BinaryValue>` | `and​(ZeroOrOne<Base64BinaryValue> value1, ZeroOrOne<Base64BinaryValue> value2)` |
    `static ZeroOrOne<Base64BinaryValue>` | `bin​(ZeroOrOne<StringValue> s)` |
    `static ZeroOrOne<StringValue>` | `decodeString​(ZeroOrOne<Base64BinaryValue> value)` |
    `static ZeroOrOne<StringValue>` | `decodeString​(ZeroOrOne<Base64BinaryValue> value, One<StringValue> encoding)` |
    `static ZeroOrOne<StringValue>` | `decodeString​(ZeroOrOne<Base64BinaryValue> value, One<StringValue> encoding, One<IntegerValue> offset)` |
    `static ZeroOrOne<StringValue>` | `decodeString​(ZeroOrOne<Base64BinaryValue> value, One<StringValue> encoding, One<IntegerValue> offset, One<IntegerValue> size)` |
    `static ZeroOrOne<Base64BinaryValue>` | `encodeString​(ZeroOrOne<StringValue> value)` |
    `static ZeroOrOne<Base64BinaryValue>` | `encodeString​(ZeroOrOne<StringValue> value, One<StringValue> encoding)` |
    `static ZeroOrOne<IntegerValue>` | `find​(ZeroOrOne<Base64BinaryValue> value, One<Base64BinaryValue> search)` |
    `static ZeroOrOne<IntegerValue>` | `find​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> offset, One<Base64BinaryValue> search)` |
    `static One<Base64BinaryValue>` | `fromOctets​(ZeroOrMore<IntegerValue> value)` |
    `static ZeroOrOne<Base64BinaryValue>` | `hex​(ZeroOrOne<StringValue> s)` |
    `static ZeroOrOne<Base64BinaryValue>` | `insertBefore​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> offset, ZeroOrOne<Base64BinaryValue> extra)` |
    `static One<Base64BinaryValue>` | `join​(ZeroOrMore<Base64BinaryValue> value)` |
    `static One<IntegerValue>` | `length​(One<Base64BinaryValue> value)` |
    `static ZeroOrOne<Base64BinaryValue>` | `not​(ZeroOrOne<Base64BinaryValue> value)` |
    `static ZeroOrOne<Base64BinaryValue>` | `octal​(ZeroOrOne<StringValue> s)` |
    `static ZeroOrOne<Base64BinaryValue>` | `or​(ZeroOrOne<Base64BinaryValue> value1, ZeroOrOne<Base64BinaryValue> value2)` |
    `static One<Base64BinaryValue>` | `packDouble​(One<DoubleValue> value)` |
    `static One<Base64BinaryValue>` | `packDouble​(One<DoubleValue> value, One<StringValue> endian)` |
    `static One<Base64BinaryValue>` | `packFloat​(One<FloatValue> value)` |
    `static One<Base64BinaryValue>` | `packFloat​(One<FloatValue> value, One<StringValue> endian)` |
    `static One<Base64BinaryValue>` | `packInteger​(One<IntegerValue> value, One<IntegerValue> length)` |
    `static One<Base64BinaryValue>` | `packInteger​(One<IntegerValue> value, One<IntegerValue> length, One<StringValue> endian)` |
    `static ZeroOrOne<Base64BinaryValue>` | `padLeft​(ZeroOrOne<Base64BinaryValue> value, IntegerValue size)` |
    `static ZeroOrOne<Base64BinaryValue>` | `padLeft​(ZeroOrOne<Base64BinaryValue> value, IntegerValue sizeIV, IntegerValue octet)` |
    `static ZeroOrOne<Base64BinaryValue>` | `padRight​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> size)` |
    `static ZeroOrOne<Base64BinaryValue>` | `padRight​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> sizeIV, One<IntegerValue> octet)` |
    `static ZeroOrOne<Base64BinaryValue>` | `part​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> offset)` |
    `static ZeroOrOne<Base64BinaryValue>` | `part​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> offset, One<IntegerValue> length)` |
    `static ZeroOrOne<Base64BinaryValue>` | `shift​(ZeroOrOne<Base64BinaryValue> value, One<IntegerValue> bitsIV)` |
    `static ZeroOrMore<IntegerValue>` | `toOctets​(One<Base64BinaryValue> value)` |
    `static One<DoubleValue>` | `unpackDouble​(One<Base64BinaryValue> value, One<IntegerValue> offset)` |
    `static One<DoubleValue>` | `unpackDouble​(One<Base64BinaryValue> value, One<IntegerValue> offset, One<StringValue> endian)` |
    `static One<FloatValue>` | `unpackFloat​(One<Base64BinaryValue> value, One<IntegerValue> offset)` |
    `static One<FloatValue>` | `unpackFloat​(One<Base64BinaryValue> value, One<IntegerValue> offset, One<StringValue> endian)` |
    `static One<IntegerValue>` | `unpackInteger​(One<Base64BinaryValue> value, One<IntegerValue> offset, One<IntegerValue> length)` |
    `static One<IntegerValue>` | `unpackInteger​(One<Base64BinaryValue> value, One<IntegerValue> offset, One<IntegerValue> length, One<StringValue> endian)` |
    `static One<IntegerValue>` | `unpackUnsignedInteger​(One<Base64BinaryValue> value, One<IntegerValue> offset, One<IntegerValue> length)` |
    `static One<IntegerValue>` | `unpackUnsignedInteger​(One<Base64BinaryValue> value, One<IntegerValue> offset, One<IntegerValue> length, One<StringValue> endian)` |
    `static One<BigDecimalValue>` | `version()` |
    `static ZeroOrOne<Base64BinaryValue>` | `xor​(ZeroOrOne<Base64BinaryValue> value1, ZeroOrOne<Base64BinaryValue> value2)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### VERSION

          public static final double VERSION

      See Also:
        Constant Field Values

    - #### NAMESPACE

          public static final java.lang.String NAMESPACE

      See Also:
        Constant Field Values

    - #### PREFIX

          public static final java.lang.String PREFIX

      See Also:
        Constant Field Values

    - #### ERROR_NAMESPACE

          public static final java.lang.String ERROR_NAMESPACE

      See Also:
        Constant Field Values

    - #### ERROR_PREFIX

          public static final java.lang.String ERROR_PREFIX

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EXPathBinary

          public EXPathBinary()

  - ### Method Detail

    - #### version

          public static One<BigDecimalValue> version()

    - #### hex

          public static ZeroOrOne<Base64BinaryValue> hex​(ZeroOrOne<StringValue> s)
                                                  throws XPathException

      Throws:
        `XPathException`

    - #### bin

          public static ZeroOrOne<Base64BinaryValue> bin​(ZeroOrOne<StringValue> s)
                                                  throws XPathException

      Throws:
        `XPathException`

    - #### octal

          public static ZeroOrOne<Base64BinaryValue> octal​(ZeroOrOne<StringValue> s)
                                                    throws XPathException

      Throws:
        `XPathException`

    - #### length

          public static One<IntegerValue> length​(One<Base64BinaryValue> value)

    - #### toOctets

          public static ZeroOrMore<IntegerValue> toOctets​(One<Base64BinaryValue> value)

    - #### fromOctets

          public static One<Base64BinaryValue> fromOctets​(ZeroOrMore<IntegerValue> value)
                                                   throws XPathException

      Throws:
        `XPathException`

    - #### join

          public static One<Base64BinaryValue> join​(ZeroOrMore<Base64BinaryValue> value)
                                             throws XPathException

      Throws:
        `XPathException`

    - #### insertBefore

          public static ZeroOrOne<Base64BinaryValue> insertBefore​(ZeroOrOne<Base64BinaryValue> value,
                                                                  One<IntegerValue> offset,
                                                                  ZeroOrOne<Base64BinaryValue> extra)
                                                           throws XPathException

      Throws:
        `XPathException`

    - #### part

          public static ZeroOrOne<Base64BinaryValue> part​(ZeroOrOne<Base64BinaryValue> value,
                                                          One<IntegerValue> offset)
                                                   throws XPathException

      Throws:
        `XPathException`

    - #### part

          public static ZeroOrOne<Base64BinaryValue> part​(ZeroOrOne<Base64BinaryValue> value,
                                                          One<IntegerValue> offset,
                                                          One<IntegerValue> length)
                                                   throws XPathException

      Throws:
        `XPathException`

    - #### find

          public static ZeroOrOne<IntegerValue> find​(ZeroOrOne<Base64BinaryValue> value,
                                                     One<Base64BinaryValue> search)
                                              throws XPathException

      Throws:
        `XPathException`

    - #### find

          public static ZeroOrOne<IntegerValue> find​(ZeroOrOne<Base64BinaryValue> value,
                                                     One<IntegerValue> offset,
                                                     One<Base64BinaryValue> search)
                                              throws XPathException

      Throws:
        `XPathException`

    - #### decodeString

          public static ZeroOrOne<StringValue> decodeString​(ZeroOrOne<Base64BinaryValue> value)
                                                     throws XPathException,
                                                            java.io.UnsupportedEncodingException

      Throws:
        `XPathException`
        `java.io.UnsupportedEncodingException`

    - #### decodeString

          public static ZeroOrOne<StringValue> decodeString​(ZeroOrOne<Base64BinaryValue> value,
                                                            One<StringValue> encoding)
                                                     throws XPathException,
                                                            java.io.UnsupportedEncodingException

      Throws:
        `XPathException`
        `java.io.UnsupportedEncodingException`

    - #### decodeString

          public static ZeroOrOne<StringValue> decodeString​(ZeroOrOne<Base64BinaryValue> value,
                                                            One<StringValue> encoding,
                                                            One<IntegerValue> offset)
                                                     throws java.io.UnsupportedEncodingException,
                                                            XPathException

      Throws:
        `java.io.UnsupportedEncodingException`
        `XPathException`

    - #### decodeString

          public static ZeroOrOne<StringValue> decodeString​(ZeroOrOne<Base64BinaryValue> value,
                                                            One<StringValue> encoding,
                                                            One<IntegerValue> offset,
                                                            One<IntegerValue> size)
                                                     throws java.io.UnsupportedEncodingException,
                                                            XPathException

      Throws:
        `java.io.UnsupportedEncodingException`
        `XPathException`

    - #### encodeString

          public static ZeroOrOne<Base64BinaryValue> encodeString​(ZeroOrOne<StringValue> value)
                                                           throws XPathException,
                                                                  java.io.UnsupportedEncodingException

      Throws:
        `XPathException`
        `java.io.UnsupportedEncodingException`

    - #### encodeString

          public static ZeroOrOne<Base64BinaryValue> encodeString​(ZeroOrOne<StringValue> value,
                                                                  One<StringValue> encoding)
                                                           throws XPathException,
                                                                  java.io.UnsupportedEncodingException

      Throws:
        `XPathException`
        `java.io.UnsupportedEncodingException`

    - #### unpackDouble

          public static One<DoubleValue> unpackDouble​(One<Base64BinaryValue> value,
                                                      One<IntegerValue> offset)
                                               throws XPathException

      Throws:
        `XPathException`

    - #### unpackDouble

          public static One<DoubleValue> unpackDouble​(One<Base64BinaryValue> value,
                                                      One<IntegerValue> offset,
                                                      One<StringValue> endian)
                                               throws XPathException

      Throws:
        `XPathException`

    - #### unpackFloat

          public static One<FloatValue> unpackFloat​(One<Base64BinaryValue> value,
                                                    One<IntegerValue> offset)
                                             throws XPathException

      Throws:
        `XPathException`

    - #### unpackFloat

          public static One<FloatValue> unpackFloat​(One<Base64BinaryValue> value,
                                                    One<IntegerValue> offset,
                                                    One<StringValue> endian)
                                             throws XPathException

      Throws:
        `XPathException`

    - #### unpackUnsignedInteger

          public static One<IntegerValue> unpackUnsignedInteger​(One<Base64BinaryValue> value,
                                                                One<IntegerValue> offset,
                                                                One<IntegerValue> length)
                                                         throws XPathException

      Throws:
        `XPathException`

    - #### unpackUnsignedInteger

          public static One<IntegerValue> unpackUnsignedInteger​(One<Base64BinaryValue> value,
                                                                One<IntegerValue> offset,
                                                                One<IntegerValue> length,
                                                                One<StringValue> endian)
                                                         throws XPathException

      Throws:
        `XPathException`

    - #### unpackInteger

          public static One<IntegerValue> unpackInteger​(One<Base64BinaryValue> value,
                                                        One<IntegerValue> offset,
                                                        One<IntegerValue> length)
                                                 throws XPathException

      Throws:
        `XPathException`

    - #### unpackInteger

          public static One<IntegerValue> unpackInteger​(One<Base64BinaryValue> value,
                                                        One<IntegerValue> offset,
                                                        One<IntegerValue> length,
                                                        One<StringValue> endian)
                                                 throws XPathException

      Throws:
        `XPathException`

    - #### packDouble

          public static One<Base64BinaryValue> packDouble​(One<DoubleValue> value)
                                                   throws XPathException

      Throws:
        `XPathException`

    - #### packDouble

          public static One<Base64BinaryValue> packDouble​(One<DoubleValue> value,
                                                          One<StringValue> endian)
                                                   throws XPathException

      Throws:
        `XPathException`

    - #### packFloat

          public static One<Base64BinaryValue> packFloat​(One<FloatValue> value)
                                                  throws XPathException

      Throws:
        `XPathException`

    - #### packFloat

          public static One<Base64BinaryValue> packFloat​(One<FloatValue> value,
                                                         One<StringValue> endian)
                                                  throws XPathException

      Throws:
        `XPathException`

    - #### packInteger

          public static One<Base64BinaryValue> packInteger​(One<IntegerValue> value,
                                                           One<IntegerValue> length)
                                                    throws XPathException

      Throws:
        `XPathException`

    - #### packInteger

          public static One<Base64BinaryValue> packInteger​(One<IntegerValue> value,
                                                           One<IntegerValue> length,
                                                           One<StringValue> endian)
                                                    throws XPathException

      Throws:
        `XPathException`

    - #### padLeft

          public static ZeroOrOne<Base64BinaryValue> padLeft​(ZeroOrOne<Base64BinaryValue> value,
                                                             IntegerValue size)
                                                      throws XPathException

      Throws:
        `XPathException`

    - #### padLeft

          public static ZeroOrOne<Base64BinaryValue> padLeft​(ZeroOrOne<Base64BinaryValue> value,
                                                             IntegerValue sizeIV,
                                                             IntegerValue octet)
                                                      throws XPathException

      Throws:
        `XPathException`

    - #### padRight

          public static ZeroOrOne<Base64BinaryValue> padRight​(ZeroOrOne<Base64BinaryValue> value,
                                                              One<IntegerValue> size)
                                                       throws XPathException

      Throws:
        `XPathException`

    - #### padRight

          public static ZeroOrOne<Base64BinaryValue> padRight​(ZeroOrOne<Base64BinaryValue> value,
                                                              One<IntegerValue> sizeIV,
                                                              One<IntegerValue> octet)
                                                       throws XPathException

      Throws:
        `XPathException`

    - #### shift

          public static ZeroOrOne<Base64BinaryValue> shift​(ZeroOrOne<Base64BinaryValue> value,
                                                           One<IntegerValue> bitsIV)
                                                    throws XPathException

      Throws:
        `XPathException`

    - #### not

          public static ZeroOrOne<Base64BinaryValue> not​(ZeroOrOne<Base64BinaryValue> value)

    - #### or

          public static ZeroOrOne<Base64BinaryValue> or​(ZeroOrOne<Base64BinaryValue> value1,
                                                        ZeroOrOne<Base64BinaryValue> value2)
                                                 throws XPathException

      Throws:
        `XPathException`

    - #### and

          public static ZeroOrOne<Base64BinaryValue> and​(ZeroOrOne<Base64BinaryValue> value1,
                                                         ZeroOrOne<Base64BinaryValue> value2)
                                                  throws XPathException

      Throws:
        `XPathException`

    - #### xor

          public static ZeroOrOne<Base64BinaryValue> xor​(ZeroOrOne<Base64BinaryValue> value1,
                                                         ZeroOrOne<Base64BinaryValue> value2)
                                                  throws XPathException

      Throws:
        `XPathException`